package main

import "fmt"
import "bufio"
import "os"
import "math/rand"
import "strconv"

const lungChiave int = 6
const lungValore int = 2

/* Legge lo standard input e restituisce una mappa che associa a ogni token-chiave (una stringa k) una
   sequenza di token-valore (le stringhe che sono comparse nel testo subito dopo k).
   La lunghezza delle chiave e dei valori sono specificate sopra. */
func leggi() map[string][]string {
	var risultato map[string][]string
	risultato = make(map[string][]string)

	scanner := bufio.NewScanner(os.Stdin)
	for scanner.Scan() {
		riga := scanner.Text()
		for i := 0; i < len(riga) - lungChiave - lungValore; i++ {
			chiave := riga[i : i+lungChiave]
			valore := riga[i+lungChiave : i+lungChiave+lungValore]
			risultato[chiave] = append(risultato[chiave], valore)
		}
	}
	return risultato
}

func chiaveACaso(modello map[string][]string) string {
	n := len(modello)
	i := 0
	for k, _ := range modello {
		i++
		if i == n {
			return k
		}
	}
	return ""
}

func genera(n int, modello map[string][]string, partenza string) string {
	var risultato string
	risultato = partenza
	for len(risultato) < n {
		chiave := risultato[len(risultato) - lungChiave:]
		valore, ok := modello[chiave]
		if ok {
			risultato += valore[rand.Intn(len(valore))]
		} else {
			risultato += chiaveACaso(modello)
		}
	}
	return risultato
}


func main() {
	modello := leggi()
	n, _ := strconv.Atoi(os.Args[1])
	fmt.Println(genera(n, modello, chiaveACaso(modello)))
}